package com.hxy.study.config;

import com.hxy.study.util.HttpClientHelper;
import io.searchbox.client.JestClient;
import io.searchbox.client.JestClientFactory;
import io.searchbox.client.config.HttpClientConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.net.UnknownHostException;

@Configuration
public class MainConfig {
    @Autowired
    private ElasticSearchConfig elasticSearchConfig;

    @Bean("httpClientHelper")
    public HttpClientHelper httpClientHelper() {
        return new HttpClientHelper();
    }

    @Bean
    public JestClient client() throws UnknownHostException {
        // Construct a new Jest client according to configuration via factory
        JestClientFactory factory = new JestClientFactory();
        factory.setHttpClientConfig(new HttpClientConfig
                .Builder("http://" + elasticSearchConfig.getServerIp() + ":" + elasticSearchConfig.getServerPort())
                .multiThreaded(true)
                //Per default this implementation will create no more than 2 concurrent connections per given route
                .defaultMaxTotalConnectionPerRoute(2)
                // and no more 20 connections in total
                .maxTotalConnection(20)
                .build());
        JestClient client = factory.getObject();
        return client;
    }
}
